
(* PRACTICA 3: MODULOS.
   1 B SISTEMAS.
   Modulo principal para la practica del Racional.

   NOTA IMPORTANTE:
      ESTA PRACTICA INCLUYE TRATAMIENTO DE ERRORES POR VARIABLE ENUMERADA

   PROFESOR: ANTONIO JOSE FERNANDEZ LEIVA  *)

MODULE MainRac;

  FROM Racional IMPORT RACIONAL,ERROR,Asignar,
                       LiberarMemoria,Numerador,Denominador;

  FROM BibRac IMPORT Copiar,Sumar,Restar,Multiplicar,Dividir,EsIgual;

  FROM Window IMPORT Clear;

  IMPORT IO;

  VAR r,r1,r2:RACIONAL;  (* Usaremos dos variables como entrada y una
                            para escribir el resultado *)

      parar:BOOLEAN;

      error:ERROR;

(*************************************************************)

  PROCEDURE pausa();
  BEGIN
    IO.WrLn;
    IO. WrStr("Pulse una tecla para continuar ");
    REPEAT UNTIL IO.KeyPressed();
  END pausa;

(*************************************************************)
  (* Procedimiento para chequear el resultado. Lo uso cada vez que llamo
     a una rutina de las librerias racional o Bibracional.
     Segun el tipo de error parare la ejecucion del programa (con la
     instruccion HALT) o simplemente escribo el mensaje de error
     correspondiente
   *)

  PROCEDURE VerError(error:ERROR);
  BEGIN
    CASE error OF
    | ObjetoNoCreado: IO.WrStr("No ha creado el Objeto");
                      pausa();
    | DivisionPorCero : IO.WrStr("Division Por cero");
                      pausa();
    | SinMemoria: IO.WrStr("No hay memoria para crear el Racional");
                      pausa();
    END;
  END VerError;

(*************************************************************)
  PROCEDURE Menu;
    BEGIN
      Clear;
      IO.WrStr("Opciones a elegir para la manipulacion de racionales");
      IO.WrLn;
      IO.WrStr("      0. Introducir primer Racional");IO.WrLn;
      IO.WrStr("      1. Introducir segundo Racional");IO.WrLn;
      IO.WrStr("      2. Copiar primer racional en segundo");IO.WrLn;
      IO.WrStr("      3. Sumar primer y segundo racional");IO.WrLn;
      IO.WrStr("      4. Restar segundo racional al primero");IO.WrLn;
      IO.WrStr("      5. Multiplicar primer y segundo racional");IO.WrLn;
      IO.WrStr("      6. Dividir primer racional por el segundo");IO.WrLn;
      IO.WrStr("      7. Son Iguales el primer y el segundo racional?");IO.WrLn;
      IO.WrStr("      8. Salir");IO.WrLn;
      IO.WrStr("Elija una opcion. No se Olvide introducir los racionales");
  END Menu;

(*************************************************************)
  (* Lectura de datos de un racional *)
  PROCEDURE Leer(VAR rac:RACIONAL);
    VAR num,den:INTEGER;
        error:ERROR;
  BEGIN
    IO.WrLn;
    IO.WrStr("Introduzca numerador ");
    num:=IO.RdInt();

    IO.WrLn;
    IO.WrStr("Introduzca denominador ");
    den:=IO.RdInt();

    Asignar(rac,num,den,error);
    VerError(error);
  END Leer;

(*************************************************************)
  PROCEDURE Visualizar(rac:RACIONAL);
    VAR num,den:INTEGER;
        error:ERROR;
  BEGIN
    num:=Numerador(rac,error);
    VerError(error);

    den:=Denominador(rac,error);
    VerError(error);

    IO.WrLn; IO.WrLn;
    IO.WrStr("El numero racional es el ");
    IO.WrInt(num,2);
    IO.WrStr("/");
    IO.WrInt(den,2);
    IO.WrLn;
    pausa();
  END Visualizar;

(*************************************************************)
  PROCEDURE ElegirOpcion(VAR salir:BOOLEAN);
  VAR opcion:CHAR;
      igual:BOOLEAN;
    BEGIN
      salir:=FALSE;
      opcion:=IO.RdKey();
      Clear;
      CASE opcion OF
        '0':IO.WrStr("Introduzca el primer Racional");
            IO.WrLn;
            Leer(r1);

      |  '1': IO.WrStr("Introduzca el segundo Racional");
            IO.WrLn;
            Leer(r2);
            Clear

      | '2':IO.WrStr("COPIAR ");IO.WrLn;
            Copiar(r1,r2,error);
            VerError(error);
            Visualizar(r2)

      | '3':IO.WrStr("SUMAR");IO.WrLn;
            Sumar(r1,r2,r,error);
            VerError(error);
            Visualizar(r)

      | '4':IO.WrStr("RESTAR");IO.WrLn;
            Restar(r1,r2,r,error);
            VerError(error);
            Visualizar(r)

      | '5':IO.WrStr("MULTIPLICAR");IO.WrLn;
            Multiplicar(r1,r2,r,error);
            VerError(error);
            Visualizar(r);

      | '6':IO.WrStr("DIVIDIR");IO.WrLn;
            Dividir(r1,r2,r,error);
            VerError(error);
            Visualizar(r)

      | '7':IO.WrStr("IGUALES?");IO.WrLn;
            igual:=EsIgual(r1,r2,error);
            VerError(error);

            IO.WrLn;
            IF igual THEN
                 IO.WrStr("Si, Son iguales")
            ELSE
                 IO.WrStr("No, Son distintos")
            END;
            IO.WrLn;
            pausa();

      | '8':salir:=TRUE
      END;

    END ElegirOpcion;

BEGIN

  parar:=FALSE;

  REPEAT
    Menu;
    ElegirOpcion(parar)
  UNTIL parar;

  LiberarMemoria(r,error);  VerError(error);
  LiberarMemoria(r1,error); VerError(error);
  LiberarMemoria(r2,error); VerError(error);

END MainRac.