
(* PRACTICA 3: MODULOS.
   1 B SISTEMAS.
   Implementacion del modulo de Racionales.

   NOTA IMPORTANTE:
     (1) La variable de error se usa para propagar el error
     (2) El tipo es opaco.

    PROFESOR: ANTONIO JOSE FERNANDEZ LEIVA  *)


IMPLEMENTATION MODULE Racional;

  FROM Storage IMPORT ALLOCATE, DEALLOCATE, Available;

  TYPE NUMERO = RECORD
                Numerador,Denominador:INTEGER;
              END;

  TYPE RACIONAL = POINTER TO NUMERO;

  PROCEDURE Asignar(VAR r:RACIONAL; n,d:INTEGER;VAR error:ERROR);
    VAR mcd:INTEGER;

    (* PROC. para calcular el Mcd de dos numeros *)
    PROCEDURE Mcd(Num1,Num2:INTEGER):INTEGER;
      VAR Resto:INTEGER;
    BEGIN (* Mcd *)
      Num1:=ABS(Num1);
      Num2:=ABS(Num2);
         (* Si uno de los numeros es el 0, entonces devolvemos
            como mcd es el 1 por convencion,
            aunque podriamos haber devuelto el mayor de ambos
            en realidad...... *)
      IF (Num1<>0) AND (Num2<>0) THEN
        WHILE Num1<>Num2 DO
           IF Num1 > Num2 THEN
              Num1:=Num1-Num2
           ELSE
              Num2:=Num2-Num1
           END;
        END;
      ELSE
        Num1:=1
      END;
      RETURN Num1
    END Mcd;

  BEGIN  (* Asignar *)
    error:=SinError;

    (* Primero chequeo los posibles errores *)
    IF d=0 THEN
       error:=DivisionPorCero
    ELSIF (r=NIL) AND NOT Available(SIZE(NUMERO)) THEN
           (* Vemos que no hay memoria. !Ojo, el Available se hace con tipo NUMERO! *)
       error:=SinMemoria;
    ELSIF r=NIL THEN
           (* EL racional no esta creado y hay que crearlo *)
       NEW(r)
    END;
    IF error=SinError THEN
         (* Normalizamos *)
       mcd:=Mcd(n,d);
       r^.Numerador:=n DIV mcd;
       r^.Denominador:=d DIV mcd;

       (* Mover signo al numerador *)
       IF r^.Denominador < 0 THEN
          r^.Denominador:= -r^.Denominador;
          r^.Numerador:= -r^.Numerador
       END
     END
  END Asignar;

  PROCEDURE Numerador(r:RACIONAL;VAR error:ERROR):INTEGER;
    VAR numerador:INTEGER;
  BEGIN
    numerador:=0;
    error:=SinError;
    IF r=NIL THEN
      error:=ObjetoNoCreado
    ELSE
      numerador:=r^.Numerador
    END;
    RETURN numerador
  END Numerador;


  PROCEDURE Denominador(r:RACIONAL;VAR error:ERROR):INTEGER;
    VAR denominador:INTEGER;
  BEGIN
    error:=SinError;
    IF r=NIL THEN
      (* La devolucion de 999 es cuestion de las especificaciones. En
         realidad podemos devolver cualquier cosa pues al chequear
         el error ese valor quedara invalidado. ver programa principal *)
      denominador:=999;
      error:=ObjetoNoCreado
    ELSE
      denominador:=r^.Denominador
    END;
    RETURN denominador
  END Denominador;

  PROCEDURE LiberarMemoria(VAR r:RACIONAL;VAR error:ERROR);
  BEGIN
    error:=SinError;
    IF r=NIL THEN
      (* no existe el racional - o sea nunca hicimos el asignar asi que
         devuelvo el error correspondiente *)
      error:=ObjetoNoCreado;
    ELSE
       DISPOSE(r)
    END
  END LiberarMemoria;


END Racional.